package request

// SaveEdbRefreshDefaultConfigReq
// @Description: 设置默认刷新时间配置
type SaveEdbRefreshDefaultConfigReq struct {
	Source    int                `description:"来源"`
	SubSource int                `description:"子来源"`
	Frequency string             `description:"频度"`
	List      []RefreshConfigReq `description:"刷新配置项"`
}

// RefreshConfigReq
// @Description: 刷新时间配置项
type RefreshConfigReq struct {
	RefreshFrequency    string `description:"刷新频率"`
	RefreshFrequencyDay int    `description:"具体刷新的日期"`
	RefreshTime         string `description:"刷新时间"`
	RefreshAllData      int    `description:"是否刷新所有数据，0：否，1：刷新所有数据"`
	RefreshDataNum      int    `description:"刷新单元格数"`
}

// SaveEdbRefreshConfigReq
// @Description: 设置指标的刷新时间配置
type SaveEdbRefreshConfigReq struct {
	Source          int                `description:"来源"`
	SubSource       int                `description:"子来源"`
	ClassifyId      int                `description:"分类id"`
	TerminalCode    string             `description:"终端编码"`
	SysUserId       string             `description:"操作人id"`
	Frequency       string             `description:"频度"`
	Keyword         string             `description:"关键字"`
	Status          string             `description:"状态，枚举值：启用、暂停"`
	IsSelectAll     bool               `description:"是否选择所有指标"`
	EdbSelectIdList []int              `description:"选择的指标id列表"`
	List            []RefreshConfigReq `description:"刷新配置项"`
}

// SaveEdbRefreshStatusReq
// @Description: 设置指标的刷新状态
type SaveEdbRefreshStatusReq struct {
	Source          int    `description:"来源"`
	SubSource       int    `description:"子来源"`
	ClassifyId      int    `description:"分类id"`
	TerminalCode    string `description:"终端编码"`
	SysUserId       string `description:"操作人id"`
	Frequency       string `description:"频度"`
	Keyword         string `description:"关键字"`
	Status          string `description:"状态，枚举值：启用、暂停"`
	IsSelectAll     bool   `description:"是否选择所有指标"`
	EdbSelectIdList []int  `description:"选择的指标id列表"`
	ModifyStatus    string `description:"需要更改的状态，枚举值：启用、暂停"`
}

// GetEdbRefreshConfigReq
// @Description: 获取默认配置的请求参数
type GetEdbRefreshConfigReq struct {
	Source    int `description:"指标来源ID"`
	SubSource int `description:"子来源"`
}
